module ROM65_dualboot( 
    input [5:0]addr, 
    output reg [7:0]ROMdata); 
    always @(*)
    begin
    //embedded 6502 instruction in ROM
        case(addr)
									//readbsy:
        6'b000000: ROMdata = 8'had; // LDA SerStat
        6'b000001: ROMdata = 8'hf8; 
        6'b000010: ROMdata = 8'hf0; //
        6'b000011: ROMdata = 8'h29; // AND #1 
        6'b000100: ROMdata = 8'h01; //
        6'b000101: ROMdata = 8'hd0; // BNE Serboot  
        6'b000110: ROMdata = 8'h1f; // 
        6'b000111: ROMdata = 8'haa; // TAX 
        6'b001000: ROMdata = 8'had; // LDA CFstat 
        6'b001001: ROMdata = 8'h07; // 
        6'b001010: ROMdata = 8'hee; // 
        6'b001011: ROMdata = 8'h2a; // ROL  
        6'b001100: ROMdata = 8'hb0; // BCS readbsy 
        6'b001101: ROMdata = 8'hf2; //  
        6'b001110: ROMdata = 8'ha9; // LDA #$20  
        6'b001111: ROMdata = 8'h20; //
        6'b010000: ROMdata = 8'h8d; // STA CFstat      
        6'b010001: ROMdata = 8'h07; // 
        6'b010010: ROMdata = 8'hee; //
									//chkdrq:  
        6'b010011: ROMdata = 8'had; // LDA CFstat  
        6'b010100: ROMdata = 8'h07; //  
        6'b010101: ROMdata = 8'hee; // 
        6'b010110: ROMdata = 8'h29; // AND #8 
        6'b010111: ROMdata = 8'h08; // 
        6'b011000: ROMdata = 8'hf0; // BEQ chkdrq 
        6'b011001: ROMdata = 8'hf9; //
									//getCFdata: 
        6'b011010: ROMdata = 8'had; // LDA CFdata 
        6'b011011: ROMdata = 8'h00; // 
        6'b011100: ROMdata = 8'hee; // 
        6'b011101: ROMdata = 8'h9d; // STA $b000,x 
        6'b011110: ROMdata = 8'h00; // 
        6'b011111: ROMdata = 8'hb0; // 
        
        6'b100000: ROMdata = 8'he8; // INX
        6'b100001: ROMdata = 8'hd0; // BNE getCFdata
        6'b100010: ROMdata = 8'hf7; //
        6'b100011: ROMdata = 8'h4c; // JMP $b000 
        6'b100100: ROMdata = 8'h00; //
        6'b100101: ROMdata = 8'hb0; //
									//serboot:  
        6'b100110: ROMdata = 8'had; // LDA SerData 
        6'b100111: ROMdata = 8'hf9; // 
        6'b101000: ROMdata = 8'hf0; //
									//serboot1: 
        6'b101001: ROMdata = 8'had; // LDA SerStat
        6'b101010: ROMdata = 8'hf8; // 
        6'b101011: ROMdata = 8'hf0; //  
        6'b101100: ROMdata = 8'h6a; // ROR 
        6'b101101: ROMdata = 8'h90; // BCC serboot1 
        6'b101110: ROMdata = 8'hfa; //  
        6'b101111: ROMdata = 8'had; // LDA SerData
        6'b110000: ROMdata = 8'hf9; //      
        6'b110001: ROMdata = 8'hf0; // 
        6'b110010: ROMdata = 8'h9d; // STA $b000,x 
        6'b110011: ROMdata = 8'h00; //  
        6'b110100: ROMdata = 8'hb0; //  
        6'b110101: ROMdata = 8'he8; // INX
        6'b110110: ROMdata = 8'hd0; // BNE serboot1
        6'b110111: ROMdata = 8'hf1; // 
        6'b111000: ROMdata = 8'h4c; // JMP $b000
        6'b111001: ROMdata = 8'h00; // 
        6'b111010: ROMdata = 8'hb0; // 
        6'b111011: ROMdata = 8'h03; // 
        6'b111100: ROMdata = 8'h80; // 
        6'b111101: ROMdata = 8'hff; // 
        6'b111110: ROMdata = 8'h00; // 
        6'b111111: ROMdata = 8'h02; //         

            
        endcase
    end
endmodule